
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#pragma once

#include "ExcelClone.h"
#include "InternalObject.h"

#include <vector>

class CWorkbook;
class CWorksheet;

/*
	CSheets class provides functionality of the Sheets objects by using OpenOffice. 
	It implements ISheets COM interface.
*/
class CSheets :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISheets, &IID_ISheets, &LIBID_ExcelCloneLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
    CSheets();
    ~CSheets();

    // get list of sheets from external application (initialize m_SheetVector)
    HRESULT Initialize(CWorkbook *pWorkbook);

    BEGIN_COM_MAP(CSheets)
        COM_INTERFACE_ENTRY(ISheets)
        COM_INTERFACE_ENTRY(IDispatch)
    END_COM_MAP()

public:
	// Get sheet Worksheet which specified varIndex
    STDMETHOD(get__Default)(VARIANT varIndex, IDispatch **ppSheet); 

	STDMETHOD(get_Count)(long *pRhs);

    STDMETHOD(Add)(VARIANT Before, VARIANT After, VARIANT Count, VARIANT Type, long lcid, IDispatch **ppNewSheet);

	
protected:
	CWorkbook *m_pWorkbook;
	IDispatch *m_pdSheets;	// IDispatch of the OO Sheets collection
public : 
	HRESULT GetActiveSheet(CWorksheet **ppWorksheet);
	// retrieve active sheet from collection
};

typedef CComInternalObject<CSheets> CSheetsObject;
