#include "PropertyValue.h"

/*
	CPropertyValue class implements methods that allows 
	Retrieving/setting OpenOffice object properties.
*/
CPropertyValue::CPropertyValue(IDispatch *pdParent) :
	m_pdVal(NULL)
{
	// there are many of the Open Office functions use "com.sun.star.beans.PropertyValue",
	// using this method
	CComVariant res;
	CComVariant cvStr(L"com.sun.star.beans.PropertyValue");
	HRESULT hres = AutoWrap (DISPATCH_METHOD, &res, pdParent, L"Bridge_GetStruct", 1, cvStr);
	if (hres == S_OK) 
	{
		m_pdVal = res.pdispVal;
		m_pdVal->AddRef();
	}
	else 
		m_pdVal = NULL;
}

CPropertyValue::~CPropertyValue()
{
	if (m_pdVal != NULL)
		m_pdVal->Release();
}

HRESULT CPropertyValue::SetPropertyValue(CComVariant vName, CComVariant vValue)
{
	if (m_pdVal == NULL)
		return E_INVALIDARG;
	CComVariant res;
	HRESULT hres = AutoWrap(DISPATCH_PROPERTYPUT, &res, m_pdVal, L"Name", 1, vName);
	if (FAILED (hres)) 
		return hres;
	hres = AutoWrap(DISPATCH_PROPERTYPUT, &res, m_pdVal, L"Value", 1, vValue);
		return hres;
}

BOOL CPropertyValue::IsValid()
{
	if (m_pdVal == NULL)
		return FALSE;
	else 
		return TRUE;
}

IDispatch* CPropertyValue::GetValueDispatch()
{
	return m_pdVal;
}